/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      FAT8515Slave.c								*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy8515.h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      25-NOV-2010                                   */
/*                                                                              */
/*  Original Developers   :-      Jim Chen	                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is a test program to try and reproduce a possible problem using the    */
/*   new API to send/receive via multiple 8515 channels                        	*/
/*                                                                              */
/*																				*/
/*  (C)2009 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    25/11/2010  |	    JC        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85156.h"

#include <pthread.h>
#include <math.h>
  
/* Global variables */

static CHy85156 COM1;
static long status;
UCHAR my_request[] = "I've got it. Thanks.";   //23 chars
static int port = 6;

int IPslot = 'C';
char vector = 0x0;				/* no interrupt */
int delay = 0;
int halfduplex = 0;
int delay485 = 0;
int vmeslot = 3;
	
ULONG baud = 9600;
char parity = 'N';
int stopbits = 1;
int databits = 8;
char flowctl = 0x10;
UCHAR buf[1024];
UCHAR sendbuf[1024];

/* Global variables */


/**************To simulate getch() function **********/
#include <termios.h>
#include <unistd.h>
int getsch( ) 
{
  struct termios oldt, newt;
  int            ch;
  tcgetattr( STDIN_FILENO, &oldt );
  newt = oldt;
  newt.c_lflag &= ~( ICANON | ECHO );
  tcsetattr( STDIN_FILENO, TCSANOW, &newt );
  ch = getchar();
  tcsetattr( STDIN_FILENO, TCSANOW, &oldt );
  return ch;
}
/**************To simulate getch() function **********/



int main(void)
{
	status = 0;

	printf("\nTesting Program starts......");
	int flag, num, no=0;

	do
	{
		printf("Please type IP slot (A ~ F):\n");
		IPslot = getsch() & 0xFF;		
		if(IPslot >0x60) IPslot=IPslot-0x20;
		if((IPslot-0x40>0) && (IPslot-0x40<6)) flag = 1;
	}while(flag == 0);


	//generic settings for the 8515 COM1
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay, halfduplex, delay485);
	if (status < 0)
	{
		printf("Configure 8515 for COM1 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Configured OK..\n");

	for(port=1; port<8; port++)
	{
		//setup com1 port 0 for sending
		status = COM1.Hy85156_ComsSetup(port, baud, parity, stopbits, databits, flowctl);
		if (status < 0)
		{
			printf("Setup COM1 error! %d\n", (int) status);
			return 0;	
		}else
			printf("Setup port%d OK.\n\n", port);


    	num = 0;
    	buf[0] = 0;
		no = 0;
		do
		{
    	    status = COM1.Hy85156_Read(port, &buf[num]);
			if(status > 0)
			{
    	        num += status;
				buf[num] = 0;
    	        if (strstr((const char*)buf, "\n\a") != NULL)
    	        {
    	            printf("received %d chars: %s", num, buf);
    	            usleep(10000);
	
    	            sprintf((char*)sendbuf, "%s %d.\n\a", my_request, port);
    	            status = COM1.Hy85156_Write(port, sendbuf, strlen((char*)sendbuf));
    	            num = 0;
					no++;
					if(no >= 5) break;
    	        }
				//else
    	        //    printf("received %d chars: %s\n\r", (int)status, buf);                
    	    }
		}while(1);
	}

    return(0);
}

