/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			IOC9010 PROJECT	--- Hytec IP Card API Library Testing Program		*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      Test8516Node1.c								*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy8516.h										*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      21-OCT-2009                                   */
/*                                                                              */
/*  Original Developers   :-      Jim Chen	                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is the first node of RS485 testing program                             */
/*                                                                              */
/*																				*/
/*  (C)2009 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    22/10/09    |	    JC        |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/


#include "../include/HytecIPAPI.h"
#include "../include/Hy85156.h"

#include <pthread.h>
#include <math.h>

/* Global variables */
  
static CHy85156 COM1;
static long status;
UCHAR response_from_slave[] = "Yes, I am here from ";
UCHAR sendbuf[255];

int slave = 0;

static int port = 1;

int IPslot = 'A';
char vector = 0x0;				/* no interrupt */
int delay = 0;
int halfduplex = 2;
int delay485 = 5;

int vmeslot = 0;
	
ULONG baud = 921600;
char parity = 'N'; 
int stopbits = 1;
int databits = 8;
char flowctl = 0;
int i;
/* Global variables */

void initialisePort(int portNum);

int main(void)
{ 
	status = 0;
    UCHAR buf[255];
    int num;
	printf("\nTesting Program starts......");

	//generic settings for the 8515 COM1
	status = COM1.Hy85156_Configure(vmeslot, IPslot, vector, delay);
	if (status < 0)
	{
		printf("Configure 8516 error! %d\n", (int) status);
		return 0;	
	}else
		printf("Configured slot %c OK..", IPslot);
    
    for (i=1; i<8; i++)
        initialisePort(i);

    /* main forever loop, doing nothing */
    num = 0;
    buf[0] = 0;
	do
	{
        status = COM1.Hy85156_Read(port, &buf[num]);
		if(status > 0)
		{
            num += status;
            //printf("status = %d\n", status);
            if (num >= 13)
            {
                buf[num] = 0;
                if (buf[0] == (0x30 + port))
                {
                    printf("received %d chars: %s\n", num, buf);
                    usleep(10000);

                    sprintf((char*)sendbuf, "%s %d.", response_from_slave, port);
                    status = COM1.Hy85156_Write(port, sendbuf, strlen((char*)sendbuf));
                    printf("Sent: %s\n\r", sendbuf);

                    port++;
                    if(port > 7) port = 1;
//                    usleep(1000);
//                    COM1.Hy85156_Flush(port, 0, 1);
                }
                num = 0;
            }else
                printf("received %d chars: %x\n\r", num, buf[0]);                
        }
	}while(1);

	getchar();
    return(0);
}

/* The thread that does the thing */
void initialisePort(int portNum)
{

	//setup com1 port 0 for sending
	status = COM1.Hy85156_ComsSetup(portNum, baud, parity, stopbits, databits, flowctl, halfduplex, delay485);
	if (status < 0)
	{
		printf("Setup port %d error! %d\n", portNum, (int) status);
		return;	
	}else
		printf("Setup UART %d OK.\n\n", portNum);


}
		
