/********************************************************************************/
/*    H   H Y   Y TTTTT EEEEE  CCC       HYTEC ELECTRONICS LTD                  */
/*    H   H  Y Y    T   E     C          5 Cradock Road,                        */
/*    HHHHH   Y     T   EEE   C          Reading, Berks.    Tel: 0118 9757770	*/
/*    H   H   Y     T   E     C          RG2 0JT            Fax: 0118 9757566	*/
/*    H   H   Y     T   EEEEE  CCC       Web: www.hytec-electronics.co.uk       */
/********************************************************************************/
/*                                                                              */
/*			Linux PROJECT	--- Hytec Sky Scanner Testing Program				*/
/*                                                                              */
/********************************************************************************/
/*  Source file name      :-      TipTest.c										*/
/*  Definition header file:		  HYTECIPAPI.h									*/
/*								  Hy8402.h										*/
/*								  Hy85056.h										*/
/*								  Hy85156.h										*/
/*								  HyTip120.h									*/
/*  Platform			  :		  Linux, Windows XP, Windows 2000               */
/*  Initial creation date :-      01-Feb-2010                                   */
/*                                                                              */
/*  Original Developers   :-      Jim S Chen                                    */
/********************************************************************************/
/*                                                                              */
/*  Description :-                                                              */
/*                                                                              */
/*  This is for testing Hytec IP card API library for Sky Scanner job. It 		*/
/*	inlcudes testing IP cards such as 8402, 8505/8506, 8515/8516 and Tip120		*/
/*                                                                              */
/*  Uncomment each macro define on the top that associates to the particular 	*/
/*	IP card to run the test.													*/
/*																				*/
/*  (C)2010 Hytec Electronics Ltd.												*/
/*                                                                              */
/********************************************************************************/
/*                                                                              */
/*  Modification record :-                                                      */
/*                                                                              */
/*  Date modified |     Person    |   Description of modification               */
/* ---------------|---------------|-------------------------------------------- */
/*    17/01/10    |	  Jim S Chen  |	  Initial copy								*/
/*                |               |                                             */
/*                                                                              */
/********************************************************************************/

#include "../include/HytecIPAPI.h"
#include "../include/HyTip120.h"
#include "../include/Hy85056.h"
#include "../include/Hy85156.h"
#include "../include/Hy8402.h"

#include <pthread.h>
#include <math.h>
void displaymenu(void);
int isNumber(char n);
int FetchNumber(char *cstart);

int main(void)
{
	int i=0, j, k;
	int vmeslot=3;        
	int status=0;

	printf("\nTesting Program starts...... \n\n");


	// THE BIG LOOP
	char buffer[255];
	char rcvBuf[255];

	displaymenu();
	do
	{
 		scanf("%s",buffer);
		i = strlen((char*)buffer);
		buffer[i] = 0x0d;
		buffer[i+1] = 0;

		switch (buffer[0])
		{
		case 0x31:			//strat azimuth
			printf("command %s\n", buffer);
			break;
		case 0x32:			//stop azimuth
			printf("command %s\n", buffer);
			break;
		case 0x33:			//Move elevation upwards
			i = FetchNumber(&buffer[2]);
			printf("command %s and number=%d\n", buffer, i);
			break;
		case 0x34:			//Move elevation downwards
			i = FetchNumber(&buffer[2]);
			printf("command %s and number=%d\n", buffer, i);
			break;
		case 0x35:			//fire laser
			printf("command %s\n", buffer);
			break;
		case 0x36:			//send command to 
			printf("command %s\n", buffer);
			break;
		case 0x37:			//Quit
			printf("command %s\n", buffer);
			return 0;
			break;
		}
	}while(1);

	printf("TIP120 Test finished. \n\n");
	return 0;
}

//==================End of Tip120 test example=========================

//===============Read Identities from IOC Box example===============
int FetchNumber(char *cstart)
{
	int i, l, num=0, c;
	l=strlen(cstart) - 1;
	for(i=0; i<l; i++)
	{
		c = isNumber(*(cstart + i));
		if(c == -1)
			return c;
		num = num +  (int)pow(10, l - i - 1) * c;
	}
	return num;
}

int isNumber(char n)
{
	if(n > 0x39 || n < 0x30)
		return -1;
	else
		return n - 0x30;
}

void displaymenu(void)
{
	printf("**************Select a command number***************\n");
	printf("----------------------------------------------------\n");
	printf("    												\n");
	printf("    1. Start azimuth								\n");
	printf("    2. Stop azimuth 								\n");
	printf("    3. Move elevation upwards						\n");
	printf("    4. Move elevation downwards						\n");
	printf("    5. Fire laser									\n");
	printf("    6. Send command to 								\n");
	printf("    7. Quit											\n");
	printf("     												\n");
	printf("****************************************************\n");
}
